unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCGridCell,
  VCL.TMSFNCGridOptions, Vcl.Controls, VCL.TMSFNCCustomControl,
  VCL.TMSFNCCustomScrollControl, VCL.TMSFNCGridData, VCL.TMSFNCCustomGrid,
  VCL.TMSFNCGrid, Vcl.StdCtrls, WEBLib.StdCtrls;

type
  TForm1 = class(TWebForm)
    TMSFNCGrid1: TTMSFNCGrid;
    WebCheckBox1: TWebCheckBox;
    procedure TMSFNCGrid1GetCellEditorType(Sender: TObject; ACol, ARow: Integer;
      var CellEditorType: TTMSFNCGridEditorType);
    procedure TMSFNCGrid1GetCellReadOnly(Sender: TObject; ACol, ARow: Integer;
      var AReadOnly: Boolean);
    procedure TMSFNCGrid1CellEditGetData(Sender: TObject; ACol, ARow: Integer;
      CellEditor: TWinControl; var CellString: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.TMSFNCGrid1CellEditGetData(Sender: TObject; ACol,
  ARow: Integer; CellEditor: TWinControl; var CellString: string);
begin
 if WebCheckBox1.Checked then CellString := 'abvdeef' else CellString := '01-01-2022' // wrong imput gives wrong datepicker alignment in grid
end;

procedure TForm1.TMSFNCGrid1GetCellEditorType(Sender: TObject; ACol, ARow: Integer; var CellEditorType: TTMSFNCGridEditorType);
begin
 case ACol of
  0 : CellEditorType := etDatePicker;
  1 : CellEditorType := etDatePicker;
 else
  CellEditorType := etEdit;
 end;
end;

procedure TForm1.TMSFNCGrid1GetCellReadOnly(Sender: TObject; ACol,
  ARow: Integer; var AReadOnly: Boolean);
begin
 AReadOnly := false;
end;

end.